///////////////////////////////////////////////////////////////////////////
//                                                                       //
//            File: DosFree.h                                            //
//            started on: 28/7/93                                        //
//                                                                       //
///////////////////////////////////////////////////////////////////////////
//                                                                       //
//                                                                       //
///////////////////////////////////////////////////////////////////////////

#ifndef __DOSFREE_H
#define __DOSFREE_H

#include "isc.h";

class INT28 : public ISC {

      virtual void DosIdleHook(void) {};
      virtual void isr(void);

protected:
      virtual void ShellFunc(void) {};

public:
       INT28() : ISC() {
               activate(0x28);
       };

};

class INT8 : public ISC {

      virtual void TimerHook(void) {};
      virtual void isr(void);
protected:
      char far *inDOS;
      virtual void ShellFunc(void) {};

public:
       INT8();

};


// trap for critical errors.
class TRAP : public ISC {

      virtual void isr(void) {};
public:
       TRAP() {};
};

// trap for Abort/Retry/Fail.--> converts to always Fail.
class TRAP24 : public ISC {

      virtual void isr(IREGS& regs);
public:
       TRAP24() {};
};


class DOSFREE : public INT8, public INT28 {

      int fRunning;
      virtual void ShellFunc(void);
protected:

      TRAP TrapCBreak;
      TRAP TrapMSDOSCriticalError;
      TRAP24 TrapAbortRetryFail;

      virtual void AppFunc(void);

public:

       void Go(void);
       DOSFREE();

};


#endif /* __DOSFREE_H */
